﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace ChartReproducer
{
    class ChartPageViewModel:ViewModelBase
    {
        private List<HistoricalValue> historicalPrices;

        public List<HistoricalValue> HistoricalPrices
        {
            get;set;
        }


        public ChartPageViewModel()
        {
            CalculateNumbers();
        }

        public void CalculateNumbers()
        {
            Random rnd = new Random();

            HistoricalPrices = new List<HistoricalValue>();

            for (int i = 0; i < 400; i++)
            {
                HistoricalPrices.Add(
                    new HistoricalValue
                    {
                        Date = DateTime.Today.AddDays(-i),
                        Volume = rnd.Next(200032, 542432422),
                        Close = (decimal)(rnd.Next(1, 10) * rnd.NextDouble()),
                        High = (decimal)(rnd.Next(1, 10) * rnd.NextDouble()),
                        Low = (decimal)(rnd.Next(1, 10) * rnd.NextDouble()),
                        Open = (decimal)(rnd.Next(1, 10) * rnd.NextDouble())
                    });
            }

           // HistoricalPrices = tmp;
        }

    }


    public abstract class ViewModelBase : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void SetProperty<T>(ref T Field, T Value, [CallerMemberName] string Name = "")
        {
            if (!EqualityComparer<T>.Default.Equals(Field, Value))
            {
                Field = Value;
                var handler = PropertyChanged;
                if (handler != null)
                {
                    handler(this, new PropertyChangedEventArgs(Name));
                }
            }
        }

        //private static bool? _isInDesignMode;

        protected void RaisePropertyChanged(String PropertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(PropertyName));
            }
        }


        [SuppressMessage(
        "Microsoft.Security",
        "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands",
        Justification = "The security risk here is neglectible.")]
        public static bool IsInDesignMode
        {
            get
            {
                return Windows.ApplicationModel.DesignMode.DesignModeEnabled;
            }
        }
    }
}
